<?php

require_once('JRank/JRankResultsParser.php');

define("SEARCH_FAILED_ERROR", "Search query failed. The search engine's server may be experiencing difficulties.");
define("NO_SEARCH", "Please enter your search query.");

class SearchResultsPage extends SiteTree {

	static $db = array(
	);
	static $has_one = array(
   );
}

class SearchResultsPage_Controller extends ContentController {
  const KEY = "---- INSERT YOUR KEY HERE ----";

	function init() {
		parent::init();
		
		Requirements::themedCSS("layout");
		Requirements::themedCSS("typography");
		Requirements::themedCSS("form");
	}
  
  private static function curl_get_file_contents($URL)
    {
        $c = curl_init();
        curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($c, CURLOPT_URL, $URL);
        $contents = curl_exec($c);
        curl_close($c);

        if ($contents) return $contents;
            else return FALSE;
    }
  
  function Search() {
    
    if(!isset($_REQUEST['q']))
    {
      return NO_SEARCH;
    }
    $query = urlencode($_REQUEST['q']);
    if(isset($_REQUEST['start']))
    {
      $start = $_REQUEST['start'];
      if($start == ''){
        $start = '0';
      }
    }
    else
    {
      $start = '0';
    }
    $url = "http://www.jrank.org/api/search/v2.xml?key=".self::KEY."&q=$query&start=$start";
    $searchresults = self::curl_get_file_contents($url);
    if($searchresults == FALSE)
    {
      return SEARCH_FAILED_ERROR;
    }
    else
    {
      $searchURLBase = $this->Link()."?q=$query";
      $xmlParser = new JRankResultsParser($searchURLBase);
      $xmlParseSuccess = $xmlParser->parse($searchresults, true);
      if($xmlParseSuccess == FALSE)
      {
        return SEARCH_FAILED_ERROR;
      }
      
      // Successful Return the results
      $results = array(
	     	  'MetaData' => $xmlParser->getMetaData(),
	     	  'Results' => $xmlParser->getResults(),
          'SearchURLBase' => $searchURLBase
	  	  );
      $pages = $xmlParser->getPages();
      if(count($pages) != 0)
      {
        $results['Pages'] = $pages;
      }
      return $this->customise($results);
    }
  }
} 

?>
